=== debian/changelog ===
mkl-dnn (1.0-2) unstable; urgency=medium

  * Add tester script for auto-generating autopkgtest control file.

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 27 Jul 2019 12:25:36 +0000

mkl-dnn (1.0-1) unstable; urgency=medium

  * New upstream version 1.0
  * Apply wrap-and-sort.
  * Update symbols control file.
  * Install a new header file mkldnn_config.h .
  * Patch HTML header to prevent privacy breach.
  * Override more lintian E&W.

 -- Mo Zhou <cdluminate@gmail.com>  Mon, 22 Jul 2019 09:17:36 +0000
