=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS   = hardening=+all
export DEB_CFLAGS_MAINT_APPEND   = -Wall #-pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall #-pedantic
export DEB_LDFLAGS_MAINT_APPEND  = -Wl,--as-needed

%:
	dh $@ -Scmake

# https://intel.github.io/mkl-dnn/dev_guide_build_options.html
override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=Release \
		-DMKLDNN_ARCH_OPT_FLAGS=""

override_dh_auto_build-indep:
ifeq (,$(findstring nodoc, $(DEB_BUILD_OPTIONS)))
	dh_auto_build -- doc
endif

override_dh_auto_install-indep:
	:
override_dh_auto_test-indep:
	:

override_dh_missing:
	dh_missing --list-missing

override_dh_installdocs:
	dh_installdocs -A doc/legal_information.md
	-dh_doxygen
