=== debian/tests/control ===
Test-Command: g++ $(dpkg-buildflags --get CFLAGS) $(dpkg-buildflags --get LDFLAGS) examples/cpu_cnn_inference_f32.c -lmkldnn -o tester; ./tester
Depends: gcc, g++, clang, libc6-dev, libmkldnn-dev
Restrictions: allow-stderr

Test-Command: g++ $(dpkg-buildflags --get CFLAGS) $(dpkg-buildflags --get LDFLAGS) examples/cpu_cnn_inference_f32.cpp -lmkldnn -o tester; ./tester
Depends: gcc, g++, clang, libc6-dev, libmkldnn-dev
Restrictions: allow-stderr

Test-Command: g++ $(dpkg-buildflags --get CFLAGS) $(dpkg-buildflags --get LDFLAGS) examples/cpu_cnn_training_f32.c -lmkldnn -o tester; ./tester
Depends: gcc, g++, clang, libc6-dev, libmkldnn-dev
Restrictions: allow-stderr

Test-Command: g++ $(dpkg-buildflags --get CFLAGS) $(dpkg-buildflags --get LDFLAGS) examples/cpu_cnn_training_f32.cpp -lmkldnn -o tester; ./tester
Depends: gcc, g++, clang, libc6-dev, libmkldnn-dev
Restrictions: allow-stderr

Test-Command: g++ $(dpkg-buildflags --get CFLAGS) $(dpkg-buildflags --get LDFLAGS) examples/cpu_getting_started.cpp -lmkldnn -o tester; ./tester
Depends: gcc, g++, clang, libc6-dev, libmkldnn-dev
Restrictions: allow-stderr

Test-Command: g++ $(dpkg-buildflags --get CFLAGS) $(dpkg-buildflags --get LDFLAGS) examples/cpu_memory_format_propagation.cpp -lmkldnn -o tester; ./tester
Depends: gcc, g++, clang, libc6-dev, libmkldnn-dev
Restrictions: allow-stderr

Test-Command: g++ $(dpkg-buildflags --get CFLAGS) $(dpkg-buildflags --get LDFLAGS) examples/cpu_performance_profiling.cpp -lmkldnn -o tester; ./tester
Depends: gcc, g++, clang, libc6-dev, libmkldnn-dev
Restrictions: allow-stderr

Test-Command: g++ $(dpkg-buildflags --get CFLAGS) $(dpkg-buildflags --get LDFLAGS) examples/cpu_rnn_inference_f32.cpp -lmkldnn -o tester; ./tester
Depends: gcc, g++, clang, libc6-dev, libmkldnn-dev
Restrictions: allow-stderr

Test-Command: g++ $(dpkg-buildflags --get CFLAGS) $(dpkg-buildflags --get LDFLAGS) examples/cpu_rnn_training_f32.cpp -lmkldnn -o tester; ./tester
Depends: gcc, g++, clang, libc6-dev, libmkldnn-dev
Restrictions: allow-stderr

Test-Command: clang++ $(dpkg-buildflags --get CFLAGS) $(dpkg-buildflags --get LDFLAGS) examples/cpu_cnn_inference_f32.c -lmkldnn -o tester; ./tester
Depends: gcc, g++, clang, libc6-dev, libmkldnn-dev
Restrictions: allow-stderr

Test-Command: clang++ $(dpkg-buildflags --get CFLAGS) $(dpkg-buildflags --get LDFLAGS) examples/cpu_cnn_inference_f32.cpp -lmkldnn -o tester; ./tester
Depends: gcc, g++, clang, libc6-dev, libmkldnn-dev
Restrictions: allow-stderr

Test-Command: clang++ $(dpkg-buildflags --get CFLAGS) $(dpkg-buildflags --get LDFLAGS) examples/cpu_cnn_training_f32.c -lmkldnn -o tester; ./tester
Depends: gcc, g++, clang, libc6-dev, libmkldnn-dev
Restrictions: allow-stderr

Test-Command: clang++ $(dpkg-buildflags --get CFLAGS) $(dpkg-buildflags --get LDFLAGS) examples/cpu_cnn_training_f32.cpp -lmkldnn -o tester; ./tester
Depends: gcc, g++, clang, libc6-dev, libmkldnn-dev
Restrictions: allow-stderr
